Inconsistency between Date and Time.strftime("%v")

08/13/2017 02:48 PM - osteele (Oliver Steele)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0:

UNKNOWN

Description

This seems odd. Each function matches its documentation, but the document and implementation of Date.strftime("%v") differs from

the documentation and implementations of Time.strftime("%v") and DateTime.strftime("%v").

ruby --version

ruby 2.4.1p111 (2017-03-22 revision 58053) [x86_64-darwin16]

 
require 'time'

# https://ruby-doc.org/stdlib-2.4.1/libdoc/date/rdoc/Date.html#method-i-strftime

# %v - VMS date (%e-%b-%Y)

d = Date.iso8601 "2006-01-02T15:04:05-05:00"

puts d.strftime("%v")           # -> 2-Jan-2006

puts d.strftime("%e-%b-%Y")     # -> 2-Jan-2006

# https://ruby-doc.org/stdlib-2.4.1/libdoc/date/rdoc/DateTime.html#method-i-strftime

# %v - VMS date (%e-%b-%Y)

dt = DateTime.iso8601 "2006-01-02T15:04:05-05:00"

puts dt.strftime("%v")          # -> 2-Jan-2006

puts dt.strftime("%e-%b-%Y")    # -> 2-Jan-2006

# https://ruby-doc.org/core-2.4.1/Time.html#method-i-strftime

# %v - VMS date (%e-%^b-%4Y)

t = Time.iso8601 "2006-01-02T15:04:05-05:00"

puts t.strftime("%v")           # 2-JAN-2006

puts t.strftime("%e-%^b-%4Y")   # 2-JAN-2006

Related issues:

Related to Ruby - Bug #4662: Date#strftime %v gives allcaps instead of normal... Closed 05/10/2011

Associated revisions

Revision f9f7f3a75ec5af4a70e3332f8f5aa300c13432e2 - 09/28/2021 08:34 AM - jeremyevans (Jeremy Evans)

[ruby/date] Make %v strftime flag use uppercase month

%v is supposed to be the VMS date, and VMS date format uses an

uppercase month.

Ruby 1.8 used an uppercase month for %v, but the behavior was

changed without explanation in r31672.

Time#strftime still uses an uppercase month for %v, so this change

makes Date#strftime consistent with Time#strftime.

Fixes [Bug #13810]

https://github.com/ruby/date/commit/56c489fd7e

Revision f9f7f3a75ec5af4a70e3332f8f5aa300c13432e2 - 09/28/2021 08:34 AM - jeremyevans (Jeremy Evans)

[ruby/date] Make %v strftime flag use uppercase month

%v is supposed to be the VMS date, and VMS date format uses an

uppercase month.
https://github.com/ruby/date/commit/56c489fd7e


Ruby 1.8 used an uppercase month for %v, but the behavior was

changed without explanation in r31672.

Time#strftime still uses an uppercase month for %v, so this change

makes Date#strftime consistent with Time#strftime.

Fixes [Bug #13810]

https://github.com/ruby/date/commit/56c489fd7e

Revision f9f7f3a7 - 09/28/2021 08:34 AM - jeremyevans (Jeremy Evans)

[ruby/date] Make %v strftime flag use uppercase month

%v is supposed to be the VMS date, and VMS date format uses an

uppercase month.

Ruby 1.8 used an uppercase month for %v, but the behavior was

changed without explanation in r31672.

Time#strftime still uses an uppercase month for %v, so this change

makes Date#strftime consistent with Time#strftime.

Fixes [Bug #13810]

https://github.com/ruby/date/commit/56c489fd7e

History

#1 - 08/14/2017 12:20 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Feedback

At r31672, date changed it but no description or rationale.

ext/date/date_strftime(date_strftime_with_tmx): "%v" means "%e-%b-%Y".

 Does anybody have any pointers?

#2 - 08/14/2017 05:30 PM - osteele (Oliver Steele)

Ruby's Time.strftime method (where %v is equivalent to %e-%^b-%4Y) is compatible with VMS time format, and Date.strftime and DateTime.strftime

(where it is equivalent to %e-%b-%Y) are not, according to section 27.1.1 Absolute Time Format of "OpenVMS Programming Concepts Manual":

The operating system uses the following format for absolute time. […]

 dd-MMM-yyyy hh:mm:ss.cc

[…]

MMM Month (first 3 characters of the month in uppercase)

#3 - 08/14/2017 10:11 PM - wanabe (_ wanabe)

- Related to Bug #4662: Date#strftime %v gives allcaps instead of normal caps added

#4 - 07/27/2021 09:38 AM - hsbt (Hiroshi SHIBATA)

- Tracker changed from Misc to Bug

- Backport set to 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0: UNKNOWN

#5 - 07/27/2021 05:35 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Feedback to Open

I submitted a pull request upstream to fix this: https://github.com/ruby/date/pull/35.  However, I'm not sure if the consistency benefit is worth the

backwards incompatibility cost.

#6 - 09/13/2021 08:34 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Open to Closed
